--[[
/*******************************************************************************\
*                                                                               *
* DebugToggleSwitch.lua                                                         *
*                                                                               *
*********************************************************************************
* Licensed under the MIT or X11 License                                         *
*                                                                               *
* Copyright (c) 2015 Eisbearg                                                   *
*                                                                               *
* Permission is hereby granted, free of charge, to any person obtaining a copy  *
* of this software and associated documentation files (the "Software"), to deal *
* in the Software without restriction, including without limitation the rights  *
* to use, copy, modify, merge, publish, distribute, sublicense, and/or sell     *
* copies of the Software, and to permit persons to whom the Software is         *
* furnished to do so, subject to the following conditions:                      *
*                                                                               *
* The above copyright notice and this permission notice shall be included in    *
* all copies or substantial portions of the Software.                           *
*                                                                               *
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR    *
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,      *
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE   *
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER        *
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, *
* OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN     *
* THE SOFTWARE.                                                                 *
\*******************************************************************************/
--]]


source("dataS/scripts/vehicles/specializations/Vehicle.lua");
  
  
DebugToggleSwitch = {};
DebugToggleSwitch_mt = Class(DebugToggleSwitch, Placeable);
InitObjectClass(DebugToggleSwitch, "DebugToggleSwitch");


function DebugToggleSwitch:new(isServer, isClient, customMt)
    local self = Placeable:new(isServer, isClient, DebugToggleSwitch_mt);
    registerObjectClassName(self, "DebugToggleSwitch");
    return self;
end;


function DebugToggleSwitch:delete()
    removeTrigger(self.triggerId);
    unregisterObjectClassName(self);
    DebugToggleSwitch:superClass().delete(self);
end;


function DebugToggleSwitch:deleteFinal()
    DebugToggleSwitch:superClass().deleteFinal(self);
end;


function DebugToggleSwitch:load(xmlFilename, x,y,z, rx,ry,rz, moveMode, initRandom)
    if not DebugToggleSwitch:superClass().load(self, xmlFilename, x,y,z, rx,ry,rz, moveMode, initRandom) then
        return false;
    end;
	if not moveMode then
		local xmlFile = loadXMLFile("TempXML", xmlFilename);
		self:finishPlacement(id, xmlFile);
		delete(xmlFile);
	end;
    return true;
end;

function DebugToggleSwitch:finishPlacement(id, xmlFile)
	self.triggerId = Utils.indexToObject(self.nodeId, "0>0");
	addTrigger(self.triggerId, "triggerCallback", self);
end;


function DebugToggleSwitch:triggerCallback(triggerId, otherId, onEnter, onLeave, onStay, otherShapeId)
	if onEnter and g_server ~= nil then
		Vehicle.consoleCommandToggleDebugRendering();
	end;
end;


function DebugToggleSwitch:update(dt)
end;


function DebugToggleSwitch:updateTick(dt)
end;


function DebugToggleSwitch:calculateMonetary(vehicle)
end;


function DebugToggleSwitch:setWarning(vehicle, toFast, price)
end;


registerPlaceableType("DebugToggleSwitch", DebugToggleSwitch);